#if !defined(AFX_JPEGMARKER_H__EB4E7680_05A1_4648_B2F9_08F997FAC744__INCLUDED_)
#define AFX_JPEGMARKER_H__EB4E7680_05A1_4648_B2F9_08F997FAC744__INCLUDED_

typedef enum {       // JPEG marker codes
   M_SOF0  = 0xc0,   // Start Of Frame N 
   M_SOF1  = 0xc1,   // N indicates which compression process
   M_SOF2  = 0xc2,   // Only SOF0-SOF2 are now in common use
   M_SOF3  = 0xc3,
  
   M_SOF5  = 0xc5,   // NB: codes C4 and CC are NOT SOF markers
   M_SOF6  = 0xc6,
   M_SOF7  = 0xc7,
  
   M_JPG   = 0xc8,
   M_SOF9  = 0xc9,
   M_SOF10 = 0xca,
   M_SOF11 = 0xcb,
  
   M_SOF13 = 0xcd,
   M_SOF14 = 0xce,
   M_SOF15 = 0xcf,
  
   M_DHT   = 0xc4,
  
   M_DAC   = 0xcc,
  
   M_RST0  = 0xd0,
   M_RST1  = 0xd1,
   M_RST2  = 0xd2,
   M_RST3  = 0xd3,
   M_RST4  = 0xd4,
   M_RST5  = 0xd5,
   M_RST6  = 0xd6,
   M_RST7  = 0xd7,
  
   M_SOI   = 0xd8,   // Start Of Image (beginning of datastream)
   M_EOI   = 0xd9,   // End Of Image (end of datastream)
   M_SOS   = 0xda,   // Start Of Scan (begins compressed data)
   M_DQT   = 0xdb,
   M_DNL   = 0xdc,
   M_DRI   = 0xdd,
   M_DHP   = 0xde,
   M_EXP   = 0xdf,
  
   M_APP0  = 0xe0,   // Application-specific marker, type N
   M_APP1  = 0xe1,
   M_APP2  = 0xe2,
   M_APP3  = 0xe3,
   M_APP4  = 0xe4,
   M_APP5  = 0xe5,
   M_APP6  = 0xe6,
   M_APP7  = 0xe7,
   M_APP8  = 0xe8,
   M_APP9  = 0xe9,
   M_APP10 = 0xea,
   M_APP11 = 0xeb,
   M_APP12 = 0xec,   // (we don't bother to list all 16 APPn's)
   M_APP13 = 0xed,
   M_APP14 = 0xee,
   M_APP15 = 0xef,
  
   M_JPG0  = 0xf0,
   M_JPG13 = 0xfd,
   M_COM   = 0xfe,   // COMment
                     // 0xff is a reserved code
   M_TEM   = 0x01,
   M_NULL  = 0,
  
   M_ERROR = 0x100
} JPEG_MARKER;

typedef enum {       // EXIF tags
   //IFD0
   EX_IMAGE_DESCRIPTION       = 0x010e,
   EX_MAKE                    = 0x010f,
   EX_MODEL                   = 0x0110,
   EX_ORIENTATION             = 0x0112,
   EX_X_RESOLUTION            = 0x011a,
   EX_Y_RESOLUTION            = 0x011b,
   EX_RESOLUTION_UNIT         = 0x0128,
   EX_SOFTWARE                = 0x0131,
   EX_DATETIME                = 0x0132,
   EX_WHITE_POINT             = 0x013e,
   EX_PRIMARY_CHROMATICITIES  = 0x013f,
   EX_YCBCR_COEFFICIENTS      = 0x0211,
   EX_YCBCR_POSITIONING       = 0x0213,
   EX_REFERENCE_BLACK_WHITE   = 0x0214,
   EX_COPYRIGHT               = 0x8298,
   EX_EXIF_OFFSET             = 0x8769,
   //SubIFD
   EX_EXPOSURE_TIME           = 0x829a,
   EX_F_NUMBER                = 0x829d,
   EX_EXPOSURE_PROGRAM        = 0x8822,
   EX_ISO_SPEED_RATING        = 0x8827,
   EX_EXIF_VERSION            = 0x9000,
   EX_DATETIME_ORIGINAL       = 0x9003,
   EX_DATETIME_DIGITIZED      = 0x9004,
   EX_COMPONENT_CONFIGURATION = 0x9101,
   EX_COMPRESSED_BITS_PER_PIXEL=0x9102,
   EX_SHUTTER_SPEED_VALUE     = 0x9201,
   EX_APERTURE_VALUE          = 0x9202,
   EX_BRIGHTNESS_VALUE        = 0x9203,
   EX_EXPOSURE_BIAS_VALUE     = 0x9204,
   EX_MAX_APERTURE_VALUE      = 0x9205,
   EX_SUBJECT_DISTANCE        = 0x9206,
   EX_METERING_MODE           = 0x9207,
   EX_LIGHT_SOURCE            = 0x9208,
   EX_FLASH                   = 0x9209,
   EX_FOCAL_LENGTH            = 0x920a,
   EX_MAKER_NOTE              = 0x927c,
   EX_USER_COMMENT            = 0x9286,
   EX_FLASHPIX_VERSION        = 0xa000,
   EX_COLORSPACE              = 0xa001,
   EX_EXIF_IMAGE_WIDTH        = 0xa002,
   EX_EXIF_IMAGE_HEIGHT       = 0xa003,
   EX_RELATED_SOUND_FILE      = 0xa004,
   EX_EXIF_INTEROPERABILITY_OFS=0xa005,
   EX_FOCALPLANE_X_RESOLUTION = 0xa20e,
   EX_FOCALPLANE_Y_RESOLUTION = 0xa20f,
   EX_FOCALPLANE_RESOLUTION_UNIT=0xa210,
   EX_EXPOSURE_INDEX          = 0xa215,
   EX_SENSING_METHOD          = 0xa217,
   EX_FILESOURCE              = 0xa300,
   EX_SCENETYPE               = 0xa301,
   //IFD1 (thumbnail IDF)
   EX_IMAGE_WIDTH             = 0x0100,
   EX_IMAGE_LENGTH            = 0x0101,
   EX_BITS_PER_SAMPLE         = 0x0102,
   EX_COMPRESSION             = 0x0103,
   EX_PHOTOMETRIC_INTERPRETATION=0x0106,
   EX_STRIP_OFFSET            = 0x0111,   // no compressed image data
   EX_SAMPLES_PER_PIXEL       = 0x0115,
   EX_ROWS_PER_STRIP          = 0x0116,
   EX_STRIP_BYTE_COUNTS       = 0x0117,
// EX_X_RESOLUTION            = 0x011a,   // yet define in IDF0
// EX_Y_RESOLUTION            = 0x011b,
   EX_PLANAR_CONFIGURATION    = 0x011c,
// EX_RESOLUTION_UNIT         = 0x0128,
   EX_JPEG_IF_OFFSET          = 0x0201,   // compressed image data
   EX_JPEG_IF_BYTECOUNT       = 0x0202,   // compressed image data bytes count
// EX_YCBCR_COEFFICIENTS      = 0x0211,
   EX_YCBCR_SUB_SAMPLING      = 0x0212,
// EX_YCBCR_POSITIONING       = 0x0213,
// EX_REFERENCE_BLACK_WHITE   = 0x0214
};

typedef enum {    // EXIF Orientation
   LC_NULL,
   // horiz_line, vertical_column
   LC_TOP_LEFT,
   LC_TOP_RIGHT,
   LC_BOTTOM_RIGHT,
   LC_BOTTOM_LEFT,
   // vertical_line, horiz_column
   LC_LEFT_TOP,
   LC_RIGHT_TOP,
   LC_RIGHT_BOTTOM,
   LC_LEFT_BOTTOM,
   LC_MORE = 0x10
};

typedef enum {                // orientation operators
   OPER_NULL,
   OPER_R90CW, OPER_R270CCW,  // same effect as OPER_R90CW
   OPER_R180,
   OPER_R270CW, OPER_R90CCW,  // same effect as OPER_R270CW
   OPER_HFLIP,                // horizontal flip
   OPER_VFLIP                 // vertical flip
};

#endif //#define AFX_JPEGMARKER_H__EB4E7680_05A1_4648_B2F9_08F997FAC744__INCLUDED_
